#ifndef EFL_UI_FORMAT_IMPL_HH
#define EFL_UI_FORMAT_IMPL_HH

#include "efl_ui_format.eo.hh"

namespace efl { namespace ui { 
#ifdef EFL_BETA_API_SUPPORT
template <typename F>
inline ::efl::eolian::return_traits<void>::type Format::format_cb_set(F func) const
{
    auto fw_func = new ::efl::eolian::function_wrapper<Efl_Ui_Format_Func_Cb, F>(func);
     ::efl_ui_format_cb_set(_eo_ptr(),
        fw_func->data_to_c(), fw_func->func_to_c(), fw_func->free_to_c());
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Format::format_string_get() const
{
    const char * __return_value =  ::efl_ui_format_string_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Format::format_string_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type units) const
{
     ::efl_ui_format_string_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(units));
}
#endif
} } 
namespace eo_cxx {
namespace efl { namespace ui { 
#ifdef EFL_BETA_API_SUPPORT
template <typename F>
inline ::efl::eolian::return_traits<void>::type Format::format_cb_set(F func) const
{
    auto fw_func = new ::efl::eolian::function_wrapper<Efl_Ui_Format_Func_Cb, F>(func);
     ::efl_ui_format_cb_set(_eo_ptr(),
        fw_func->data_to_c(), fw_func->func_to_c(), fw_func->free_to_c());
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Format::format_string_get() const
{
    const char * __return_value =  ::efl_ui_format_string_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Format::format_string_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type units) const
{
     ::efl_ui_format_string_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(units));
}
#endif
inline efl::ui::Format::operator ::efl::ui::Format() const { return *static_cast< ::efl::ui::Format const*>(static_cast<void const*>(this)); }
inline efl::ui::Format::operator ::efl::ui::Format&() { return *static_cast< ::efl::ui::Format*>(static_cast<void*>(this)); }
inline efl::ui::Format::operator ::efl::ui::Format const&() const { return *static_cast< ::efl::ui::Format const*>(static_cast<void const*>(this)); }
} } }
#endif
